--                              -*- Mode: Ada -*-
-- Filename        : $Source: /home/ACDE/ACDE/ASCL/RCS/ascl-app-initfile.ads,v $
-- Description     : init files
-- Author          : Michael Erdmann
-- Created On      : Sat May 23 17:37:01 1998
-- Last Modified By: $Author: ACDE $
-- Last Modified On: $Date: 2000/01/23 09:48:34 $
-- Status          : $State: Released $
--
-- Functional Description
-- ======================
--
--
-- History
-- =======
-- $Log: ascl-app-initfile.ads,v $
-- Revision 1.2  2000/01/23 09:48:34  ACDE
-- Release Version base_1_1
--
-- Revision 1.1  2000/01/23 09:46:34  ACDE
-- Release Version 1_0
--
-- Revision 1.12  1999/11/27 16:56:18  ACDE
-- Release Version 1P010
--
-- Revision 1.11  1999/11/27 16:50:10  ACDE
-- Preinstallation checkin
--
-- Revision 1.10  1999/11/27 16:45:46  ACDE
-- Release Version 1P009
--
-- Revision 1.9  1999/11/27 16:44:56  ACDE
-- Preinstallation checkin
--
-- Revision 1.8  1999/11/27 16:42:27  ACDE
-- Preinstallation checkin
--
-- Revision 1.7  1999/11/27 16:38:33  ACDE
-- Preinstallation checkin
--
-- Revision 1.6  1999/11/27 16:35:39  ACDE
-- Preinstallation checkin
--
-- Revision 1.5  1999/11/27 16:33:28  ACDE
-- Preinstallation checkin
--
-- Revision 1.4  1999/11/27 16:33:00  ACDE
-- Preinstallation checkin
--
-- Revision 1.3  1999/11/27 16:30:28  ACDE
-- Preinstallation checkin
--
-- Revision 1.2  1999/11/27 15:47:05  ACDE
-- Installation checkin
--
-- Revision 1.1  1999/11/27 09:33:25  ACDE
-- Initial revision
--
-- Revision 1.1  1999/08/06 16:56:00  erdmann
-- No comments
--
--
--
--
package ASCL.App.Initfile is

   type Object is private;
   type Reference is access Object;


   procedure Initialize( This : in out Object );
   procedure Finalize( This : in out Object );

   procedure Get( This : in Object; Name : in String := "" );

   procedure Section( This : in Object; Name : in String );
   function Value( This : in Object; Name : in String) return String; 

   procedure Next( This   : in  Object;                           --#1#
		   Name   : out String;                            
                   Result : out String;
                   Last   : out Boolean;
                   First  : in  Boolean := False );


   File_Not_Found    : exception;
   Value_Not_Found   : exception;
   Section_Not_Found : exception;
   Syntax_Error      : exception;
   
private
   type Object_Data;
   type Object_Data_Access is access Object_Data;

   function Initialize return Object_Data_Access;

   type Object is record
         Data  : Object_Data_Access := Initialize;
      end record;

end ASCL.App.Initfile;
