--|  
--| Filename        : $Source: /home/ACDE/ACDE/ASCL/RCS/ascl-dt-container.ads,v $
--| Description     : Basic container class
--| Author          : Michael Erdmann
--| Created On      : 25.3.1999
--| Last Modified By: $Author: ACDE $
--| Last Modified On: $Date: 2000/01/23 09:48:34 $
--| Status          : $State: Released $
--|
--|
--| Functional Description
--| ======================
--|
--|
--| Component Data
--| ==============
--|
--|
--| Operations on the component data
--| ================================
--|
--| Error Handling
--| ==============
--|
--| Extension
--| =========
--|
--| Restrictions
--| ============
--|
--|
--| History
--| =======
--| $Log: ascl-dt-container.ads,v $
--| Revision 1.2  2000/01/23 09:48:34  ACDE
--| Release Version base_1_1
--|
--| Revision 1.1  2000/01/23 09:46:34  ACDE
--| Release Version 1_0
--|
--| Revision 1.12  1999/11/27 16:56:18  ACDE
--| Release Version 1P010
--|
--| Revision 1.11  1999/11/27 16:50:10  ACDE
--| Preinstallation checkin
--|
--| Revision 1.10  1999/11/27 16:45:46  ACDE
--| Release Version 1P009
--|
--| Revision 1.9  1999/11/27 16:44:56  ACDE
--| Preinstallation checkin
--|
--| Revision 1.8  1999/11/27 16:42:27  ACDE
--| Preinstallation checkin
--|
--| Revision 1.7  1999/11/27 16:38:33  ACDE
--| Preinstallation checkin
--|
--| Revision 1.6  1999/11/27 16:35:39  ACDE
--| Preinstallation checkin
--|
--| Revision 1.5  1999/11/27 16:33:28  ACDE
--| Preinstallation checkin
--|
--| Revision 1.4  1999/11/27 16:33:00  ACDE
--| Preinstallation checkin
--|
--| Revision 1.3  1999/11/27 16:30:28  ACDE
--| Preinstallation checkin
--|
--| Revision 1.2  1999/11/27 15:47:05  ACDE
--| Installation checkin
--|
--| Revision 1.1  1999/11/27 09:33:55  ACDE
--| sg
--|
--|
--|
with ASCL.Debugging_Support; 
use ASCL;

with ASCL.DT.Container_Element;

package ASCL.DT.Container is
   
   ---=====================================================================---
   ---===             C O M P O N E N T   I N T E R F A C E             ===---
   ---=====================================================================---
   type Object is abstract tagged private;
   type Handle is access Object'Class;

   subtype Reference is Integer;

   procedure Initialize( this  : in out Object'Class;
                         debug : in Debugging_Support.Handle := null );

   procedure Finalize( this : in out Object'Class );

   ---=====================================================================---
   ---===                  A T T R I B U T E S                       ===---
   ---=====================================================================---

   ---=====================================================================---
   ---===                     M E T H O D S                             ===---
   ---=====================================================================---

   ---------------------------------------------------------------------------
   --| Description    :
   --| Preconditions  :
   --| Postconditions :
   --| Exceptions     :
   --| Note           :
   ---------------------------------------------------------------------------

   ---=====================================================================---
   ---===                   E X T E N S I O N                           ===---
   ---=====================================================================---

   ---=====================================================================---
private
   type Object_Data;
   type Object_Data_Access is access Object_Data;

   type Object is abstract tagged record
         data : Object_Data_Access := null;
      end record; 


end ASCL.DT.Container;


