--|                              -*- Mode: Ada -*-
--| Filename        : $Source: /home/ACDE/ACDE/ASCL/RCS/ascl-dt-tree_element.ads,v $
--| Description     :
--| Author          : Michael Erdmann
--| Created On      :
--| Last Modified By: $Author: ACDE $
--| Last Modified On: $Date: 2000/01/23 09:48:34 $
--| Update Count    : 0
--| Status          : $State: Released $
--|
--| Functional Description
--| ======================
--| This is an information record which is identified by a 
--| key. 
--|
--| The following methods have to be implemented 
--|
--| Key    - Return the index of the key a a given position.
--| length - Return the key length.
--| Read   - Load data from a stream.
--| Write  - Store instance in a stream.         
--|
--| 
--|
--| History
--| =======
--| $Log: ascl-dt-tree_element.ads,v $
--| Revision 1.2  2000/01/23 09:48:34  ACDE
--| Release Version base_1_1
--|
--| Revision 1.1  2000/01/23 09:46:34  ACDE
--| Release Version 1_0
--|
--| Revision 1.7  1999/11/27 16:56:18  ACDE
--| Release Version 1P010
--|
--| Revision 1.6  1999/11/27 16:50:10  ACDE
--| Preinstallation checkin
--|
--| Revision 1.5  1999/11/27 16:45:46  ACDE
--| Release Version 1P009
--|
--| Revision 1.4  1999/11/27 16:44:56  ACDE
--| Preinstallation checkin
--|
--| Revision 1.3  1999/11/27 16:42:27  ACDE
--| Preinstallation checkin
--|
--| Revision 1.2  1999/11/27 16:40:22  ACDE
--| Preinstallation checkin
--|
--| Revision 1.1  1999/11/27 16:40:00  ACDE
--| No comments
--|
--|
--|
with Ada.Streams;              use Ada.Streams;
with Ada.Streams.Stream_IO;    use Ada.Streams.Stream_IO;
                                       
package Ascl.DT.Tree_Element is

   ---====================================================================---
   ---===         C O M P O N E N T     I N T E R F A C E              ===---
   ---====================================================================---
   type Object is abstract tagged null record;
   type Handle is access all Object'Class;

   ---====================================================================---
   ---===                A T T R I B U T E S (GET/SET)                 ===---
   ---====================================================================---
   function Key( a : in Object; pos : in Integer ) return Integer is abstract;
   function Length( a : in Object ) return Integer is abstract;

   
   ---====================================================================---
   ---===                       M E T H O D S                          ===---
   ---====================================================================--- 

   procedure Read( s : access Root_Stream_Type'Class; item : out Object )
                                                                  is abstract;
   procedure Write( s : access Root_Stream_Type'Class; item : in Object )
                                                                  is abstract;
end Ascl.DT.Tree_Element;


