--|                              -*- Mode: Ada -*-
--| Filename        : $Source: /home/ACDE/ACDE/ASCL/RCS/ascl-rt-event_q.ads,v $
--| Description     : Template Specification
--| Author          : Michael Erdmann
--| Created On      : 25.3.1999
--| Last Modified By: $Author: ACDE $
--| Last Modified On: $Date: 2000/01/23 09:48:34 $
--| Update Count    : 0
--| Status          : $State: Released $
--|
--| Functional Description
--| ======================
--|
--| An Event_q maintains two lists of events. This list of defered
--| and the list of incommning events.
--|
--|
--| Component Data
--| ==============
--|
--|
--| Operations on the component data
--| ================================
--|
--| Get
--|       Get an Event, if nothing is there then
--|       block the process.
--| Put
--|       Put an Event into the event qeue.
--|
--| Defere
--|       An event is put in the defere qeue. 
--|
--|
--| Error Handling
--| ==============
--|
--| Extension
--| =========
--|
--|
--| History
--| =======
--| $Log: ascl-rt-event_q.ads,v $
--| Revision 1.2  2000/01/23 09:48:34  ACDE
--| Release Version base_1_1
--|
--| Revision 1.1  2000/01/23 09:46:34  ACDE
--| Release Version 1_0
--|
--| Revision 1.11  1999/11/27 16:56:18  ACDE
--| Release Version 1P010
--|
--| Revision 1.2  1999/11/27 15:47:05  ACDE
--| Installation checkin
--|
--| Revision 1.1  1999/11/27 09:33:55  ACDE
--| sg
--|
--| Revision 1.1  1999/07/22 18:01:49  erdmann
--| No comments
--|
--|
--|
--|
with ASCL.RT.Event;   		  use ASCL.RT;
with ASCL.Debugging_Support;      use ASCL;

package ASCL.RT.Event_Q is
   
   ---=====================================================================---
   ---===             C O M P O N E N T   I N T E R F A C E             ===---
   ---=====================================================================---
   type Object is tagged private;
   type Handle is access Object'Class;

   procedure Initialize( this  : in out Object;
                         debug : in Debugging_Support.Handle := null );

   procedure Finalize( this : in out Object );
   ---=====================================================================---
   ---===                  A T T R I B U T E S                       ===---
   ---=====================================================================---

   ---=====================================================================---
   ---===                     M E T H O D S                             ===---
   ---=====================================================================---
   procedure Put( this : in Object'Class; evt : in Event.Handle ); 
   function  Get( this : in Object'Class ) return Event.Handle;
   procedure Defere( this : in out Object'Class; evt : in Event.Handle );

   ---=====================================================================---
   ---===                   E X T E N S I O N                           ===---
   ---=====================================================================--- 

   ---=====================================================================---
private
   type Object_Data;
   type Object_Data_Access is access Object_Data;

   type Object is tagged record
         data : Object_Data_Access := null;
      end record;



end ASCL.RT.Event_Q;


