--|                              -*- Mode: Ada -*-
--| Filename        : $Source: /home/ACDE/ACDE/ASCL/RCS/ascl-rt-state.ads,v $
--| Description     : FSM State class
--| Author          : Michael Erdmann
--| Created On      : 24.7.1999
--| Last Modified By: $Author: ACDE $
--| Last Modified On: $Date: 2000/01/23 09:48:34 $
--| Update Count    : 0
--| Status          : $State: Released $
--|
--| Functional Description
--| ======================
--|
--| A State maintans the information associated ta a certain state.
--| 
--|
--| Component Data
--| ==============
--|
--| Operations on the component data
--| ================================
--|
--| Initialize
--| Finalize 
--|
--| Respond     - This function implements the response to an
--|               event and it returns the next state to be 
--|               executed.
--|
--| Error Handling
--| ==============
--|
--| Extension
--| =========
--|
--|
--| History
--| =======
--| $Log: ascl-rt-state.ads,v $
--| Revision 1.2  2000/01/23 09:48:34  ACDE
--| Release Version base_1_1
--|
--| Revision 1.1  2000/01/23 09:46:34  ACDE
--| Release Version 1_0
--|
--|
--|
with ASCL.RT.Event;

use ASCL.RT;

package ASCL.RT.State is
   
   ---=====================================================================---
   ---===             C O M P O N E N T   I N T E R F A C E             ===---
   ---=====================================================================---
   type Object is abstract tagged private;
   type Handle is access Object'Class;

   procedure Initialize( this : in out Object ) is abstract;
   procedure Finalize( this : in out Object ) is abstract;

   type State_ID is new Natural range 0..1024;

   Final : constant State_ID := 0;

   ---=====================================================================---
   ---===                  A T T R I B U T E S                       ===---
   ---=====================================================================---
 
   ---=====================================================================---
   ---===                     M E T H O D S                             ===---
   ---=====================================================================---
 
   ---=====================================================================---
   ---===                   E X T E N S I O N                           ===---
   ---=====================================================================---

   function Respond( this : in Object; 
                     evt  : in Event.Handle ) return State_ID is abstract;

   ---=====================================================================---
private
   type Object is abstract tagged null record;
 
end ASCL.RT.State;


